// ET199.cpp : Implementation of CET199

#include "stdafx.h"
#include "ET199App.h"
#include "ET199.h"
#include "ET199_32.h"

#pragma comment(lib, "ET199_32S.lib")
ET_CONTEXT *pContext = NULL;

/////////////////////////////////////////////////////////////////////////////
// CET199

void Hex2Str(unsigned char* pIN, unsigned char* pOut, unsigned long ulLen)
{
	BYTE bTemp = 0;
	for(DWORD i=0; i<ulLen; ++i)
	{
		bTemp = pIN[i] >> 4;// & 0x0F;
		bTemp = bTemp & 0x0F;
		
		if((bTemp>=0x00) && (bTemp<=0x09))
			bTemp = bTemp + 0x30;
		else if((bTemp >= 0x0A) && (bTemp <= 0x0F))
			bTemp = bTemp + 0x37;
		
		pOut[2*i] = bTemp;
		
		bTemp = pIN[i] & 0x0F;
		
		if((bTemp>=0x00) && (bTemp<=0x09))
			bTemp = bTemp + 0x30;
		else if((bTemp >= 0x0A) && (bTemp <= 0x0F))
			bTemp = bTemp + 0x37;
		
		pOut[2*i + 1] = bTemp;
	}
	
}

void Str2Hex(unsigned char* pbIn, unsigned char* pbOut, unsigned long unLen)
{
	for(unsigned long i = 0; i < unLen >> 1; i++)
	{
		if((pbIn[2*i]>=0x30) && (pbIn[2*i]<=0x39))
			pbIn[2*i] = pbIn[2*i] - 0x30;
		else if((pbIn[2*i]>='A') && (pbIn[2*i]<='Z'))
			pbIn[2*i] = pbIn[2*i] - 0x37;
		else if((pbIn[2*i]>='a') && (pbIn[2*i]<='z'))
			pbIn[2*i] = pbIn[2*i] - 0x57;
		
		pbOut[i] = pbIn[2*i];
		pbOut[i] <<= 4;
		
		if((pbIn[2*i+1]>=0x30) && (pbIn[2*i+1]<=0x39))
			pbIn[2*i+1] = pbIn[2*i+1] - 0x30;
		else if((pbIn[2*i+1]>='A') && (pbIn[2*i+1]<='Z'))
			pbIn[2*i+1] = pbIn[2*i+1] - 0x37;
		else if((pbIn[2*i+1]>='a') && (pbIn[2*i+1]<='z'))
			pbIn[2*i+1] = pbIn[2*i+1] - 0x57;
		
		pbOut[i] += pbIn[2*i+1]; 
	}
	
}

//
void FlipBuffer(unsigned char* pBuf, unsigned long ulLen)
{
	unsigned char ucTemp;
	for(unsigned long i = 0; i < ulLen >> 1; ++i)
	{
		ucTemp = pBuf[i];
		pBuf[i] = pBuf[ulLen - i - 1];
		pBuf[ulLen - i - 1] = ucTemp;
	}
}

STDMETHODIMP CET199::GetSN(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
		
	// TODO: Add your implementation code here
	DWORD dwRet=0;
	DWORD dwCount=0;
	char pSN[16] = {0};
	int i=0;
	
	dwRet=ETEnum(NULL,&dwCount);
	if(dwRet != ET_E_INSUFFICIENT_BUFFER && dwRet)
		goto CLEAN;
	
	pContext = new ET_CONTEXT[dwCount];
	if(NULL == pContext)
		return S_FALSE;
	
	//0
	memset(pContext, 0, sizeof(ET_CONTEXT)*dwCount);
	
	if(dwCount != 1)
	{
		delete [] pContext;
		pContext = NULL;
		goto CLEAN;
	}
	
	dwRet=ETEnum(&pContext[0], &dwCount);
	if(dwRet != ET_S_SUCCESS)
	{
		delete [] pContext;
		pContext = NULL;
		goto CLEAN;
	}
	
	dwRet = ETOpen(pContext);
	if(dwRet != ET_S_SUCCESS)
	{
		delete [] pContext;
		pContext = NULL;
		goto CLEAN;
	}
	
	for(i=0; i<8; ++i)
		sprintf(pSN+2*i,"%02X",pContext->bID[i]);
	
	ETClose(pContext);
	
CLEAN:
	
	USES_CONVERSION;
	delete [] pContext;
	pContext = NULL;
	*pVal=SysAllocString(A2OLE(pSN));
	
	return S_OK;
}

STDMETHODIMP CET199::Enum(DWORD *dwCount)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	DWORD dwRet=0;
	DWORD dwDeviceCount=0;
	
	dwRet=ETEnum(NULL, &dwDeviceCount);
	if(dwRet != ET_E_INSUFFICIENT_BUFFER && dwRet)
	{
		*dwCount = -1;
		return S_FALSE;
	}
	
	USES_CONVERSION;
	*dwCount = (int)dwDeviceCount;
	
	return S_OK;
}

STDMETHODIMP CET199::Open(long *lRet)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	DWORD dwRet=0;
	DWORD dwCount=0;
	
	dwRet=ETEnum(NULL,&dwCount);
	if(dwRet != ET_E_INSUFFICIENT_BUFFER && dwRet)
	{
		*lRet = -1;
		return S_FALSE;
	}
	
	pContext = new ET_CONTEXT[dwCount];
	if(NULL == pContext)
	{
		*lRet = -4;
		return S_FALSE;
	}
	
	//0
	memset(pContext, 0, sizeof(ET_CONTEXT)*dwCount);
	
	//ʹ÷Ļ½ö
	dwRet=ETEnum(pContext, &dwCount);
	if(dwRet != ET_S_SUCCESS)
	{
		*lRet = -1;
		delete [] pContext;
		pContext = NULL;
		return S_FALSE;
	}
	
	if(dwCount != 1)
	{
		*lRet = -2;
		delete [] pContext;
		pContext = NULL;
		return S_FALSE;
	}
	
	dwRet = ETOpen(&pContext[0]);
	if(dwRet != ET_S_SUCCESS)
	{
		*lRet = -3;
		delete [] pContext;
		pContext = NULL;
		return S_FALSE;
	}
	
	return S_OK;
}

STDMETHODIMP CET199::VerifyPIN(DWORD dwFlags, BSTR pbPIN, long *lRet)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	if(pContext == NULL)
	{
		*lRet = -3;
		return S_FALSE;
	}
	
	DWORD dwRet = ET_S_SUCCESS;
	unsigned char  *pbData;
	unsigned long ulDataLen;
	
	USES_CONVERSION;
	pbData=(BYTE*)OLE2A(pbPIN);
	if(pbData != NULL)
		ulDataLen=strlen((const char*)pbData);
	else
	{
		*lRet = -4;
		return S_FALSE;
	}
	
	dwRet = ETVerifyPin(pContext, pbData, ulDataLen, dwFlags);
	if(dwRet != ET_S_SUCCESS)
	{
		*lRet = -5;
		return S_FALSE;
	}
	
	return S_OK;
}

STDMETHODIMP CET199::Write(DWORD dwOffset, DWORD dwLen, BSTR bstrData, long *lRet)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	if(pContext == NULL)
	{
		*lRet = -3;
		return S_FALSE;
	}
	
	unsigned char  *pbData;
	unsigned long ulDataLen;
	DWORD dwRet = ET_S_SUCCESS;
	
	USES_CONVERSION;
	pbData=(BYTE*)OLE2A(bstrData);
	if(pbData != NULL)
		ulDataLen=strlen((const char*)pbData);
	else
	{
		*lRet = -4;
		return S_FALSE;
	}
	
	dwRet = ETWriteFile(pContext, "20AA", dwOffset, pbData, dwLen);
	if(dwRet != ET_S_SUCCESS)
	{
		*lRet = -6;
		return S_FALSE;
	}
	
	*lRet = 0;
	
	return S_OK;
}

STDMETHODIMP CET199::Read(WORD Offset, BYTE bLen, BSTR *bstrData)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	if(pContext == NULL)
	{
		//*lRet = -4;
		return S_FALSE;
	}
	
	DWORD dwRet = ET_S_SUCCESS;
	CComBSTR bstr;
	DWORD dwOutLen = 0;
	char InBuffer[4] = {0};
	
	//C51ִ,˴
	memcpy(InBuffer, &Offset, 2); //cBufferе±Ϊ0,1Ϊƫ
	memcpy(InBuffer+2, &bLen, 1);
	
	
	unsigned char* pTemp = new unsigned char[bLen+1];
	memset(pTemp, 0, bLen+1);
	
	dwRet = ETExecute(pContext, "0001", InBuffer, 3, pTemp, bLen, &dwOutLen);
	if(dwRet != ET_S_SUCCESS)
	{
		if(pTemp != NULL)
		{
			delete [] pTemp;
			pTemp = NULL;
		}
		return S_FALSE;
	}
	
	//سΪ1ʱC51г
	if(dwOutLen == 1)
	{
		return S_FALSE;
	}
	
	bstr.Append((char*)pTemp);
	*bstrData = bstr;
	//*lRet = 0;
	
	if(pTemp != NULL)
	{
		delete [] pTemp;
		pTemp = NULL;
	}
	
	return S_OK;
}

STDMETHODIMP CET199::RSAEncrypt(BSTR bstrInData, BSTR *bstrOutData)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	if(pContext == NULL)
	{
		//*lRet = -3;
		return S_FALSE;
	}
	
	unsigned char  *pbData;
	unsigned long ulDataLen;
	DWORD dwRet = ET_S_SUCCESS;
	CComBSTR bstr;
	DWORD dwOutLen = 0;
	unsigned char OutBuf[128] = {0};
	
	USES_CONVERSION;
	pbData=(BYTE*)OLE2A(bstrInData);
	if(pbData != NULL)
		ulDataLen=strlen((const char*)pbData);
	else
	{
		//*lRet = -4;
		return S_FALSE;
	}
	
	int iN = ulDataLen/128;
	int iY = 128 - ulDataLen%128;
	int iL = (iN+1)*128;
	
	unsigned char *pTemp = new unsigned char[iL];
	memset(pTemp, 0, iL);
	memcpy(pTemp+2, pbData, ulDataLen);  //1ֽΪ02ֽڴݿ鳤
	//	memset(pTemp + iN*128+ulDataLen%128, iY, iY);
	
	pTemp[1] = (unsigned char)ulDataLen; //Ϊȷܳɹ1ֽΪ02ֽڴݿ鳤
	
	dwRet = ETExecute(pContext, "0003", pTemp, iL, OutBuf, 128, &dwOutLen);
	if(dwRet != ET_S_SUCCESS)
	{
		if(pTemp != NULL)
		{
			delete [] pTemp;
			pTemp = NULL;
		}
		return S_FALSE;
	}
	
	int iLDouble = iL*2;
	unsigned char *pTempDouble = new unsigned char[iLDouble+1];
	memset(pTempDouble, 0, iLDouble+1);
	Hex2Str(OutBuf, pTempDouble, iL);
	
	bstr.Append((char*)pTempDouble);
	*bstrOutData = bstr;
	
	if(pTempDouble != NULL)
	{
		delete [] pTempDouble;
		pTempDouble = NULL;
	}
	
	
	if(pTemp != NULL)
	{
		delete [] pTemp;
		pTemp = NULL;
	}
	
	return S_OK;
}

STDMETHODIMP CET199::RSADecrypt(BSTR bstrInData, BSTR *bstrOutData)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	if(pContext == NULL)
	{
		//*lRet = -3;
		return S_FALSE;
	}
	
	unsigned char  *pbData;
	unsigned long ulDataLen;
	DWORD dwRet = ET_S_SUCCESS;
	CComBSTR bstr;
	DWORD dwOutLen = 0;
	unsigned char OutBuf[128] = {0};
	
	USES_CONVERSION;
	pbData=(BYTE*)OLE2A(bstrInData);
	if(pbData != NULL)
		ulDataLen=strlen((const char*)pbData);
	else
	{
		//*lRet = -4;
		return S_FALSE;
	}
	
	if((ulDataLen<=0) || (ulDataLen%128 != 0))
	{
		return S_FALSE;
	}
	
	int iL = ulDataLen/2;
	unsigned char *pTemp = new unsigned char[iL];
	memset(pTemp, 0, iL);
	Str2Hex((unsigned char*)pbData, pTemp, ulDataLen);
	
	dwRet = ETExecute(pContext, "0004", pTemp, iL, OutBuf, 128, &dwOutLen);
	if(dwRet != ET_S_SUCCESS)
	{
		//*lRet = -9;
		if(pTemp != NULL)
		{
			delete [] pTemp;
			pTemp = NULL;
		}
		return S_FALSE;
	}
	
	int iLReal = OutBuf[1];
	unsigned char *pTempReal = new unsigned char[iLReal+1];
	memset(pTempReal, 0, iLReal+1);
	memcpy(pTempReal, OutBuf+2, iLReal); //1ֽΪ02ֽڴݿ鳤.3ֽԺ
	
	bstr.Append((char*)pTempReal);
	*bstrOutData = bstr;
	
	if(pTempReal != NULL)
	{
		delete [] pTempReal;
		pTempReal = NULL;
	}
	
	if(pTemp != NULL)
	{
		delete [] pTemp;
		pTemp = NULL;
	}
	
	return S_OK;
}

STDMETHODIMP CET199::SetTDESKey(BSTR pbTDesKey, long *lRet)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	if(pContext == NULL)
	{
		*lRet = -3;
		return S_FALSE;
	}
	
	unsigned char  *pbData;
	unsigned long ulDataLen;
	DWORD dwRet = ET_S_SUCCESS;
	
	USES_CONVERSION;
	pbData=(BYTE*)OLE2A(pbTDesKey);
	if(pbData != NULL)
		ulDataLen=strlen((const char*)pbData);
	else
	{
		*lRet = -4;
		return S_FALSE;
	}
	
	dwRet = ETWriteFile(pContext, "1006", 0, pbData, ulDataLen);
	if(dwRet != ET_S_SUCCESS)
	{
		*lRet = -6;
		return S_FALSE;
	}

	*lRet = 0;
	
	return S_OK;
}

STDMETHODIMP CET199::TDESEncrypt(BSTR bstrInData, BSTR *bstrOutData)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	if(pContext == NULL)
	{
		//*lRet = -3;
		return S_FALSE;
	}
	
	unsigned char  *pbData;
	unsigned long ulDataLen;
	DWORD dwRet = ET_S_SUCCESS;
	CComBSTR bstr;
	DWORD dwOutLen = 0;
	
	USES_CONVERSION;
	pbData=(BYTE*)OLE2A(bstrInData);
	if(pbData != NULL)
		ulDataLen=strlen((const char*)pbData);
	else
	{
		//*lRet = -4;
		return S_FALSE;
	}
	
	int iN = ulDataLen/128;
	int iY = 128 - ulDataLen%128;
	int iL = (iN+1)*128;
	
	unsigned char *pTemp = new unsigned char[iL];
	unsigned char *pOutBuf = new unsigned char[iL];
	memset(pTemp, 0, iL);
	memset(pOutBuf, 0, iL);
	memcpy(pTemp, pbData, ulDataLen);
	memset(pTemp + iN*128+ulDataLen%128, iY, iY);
	
	dwRet = ETExecute(pContext, "0005", pTemp, iL, pOutBuf, iL, &dwOutLen);
	if(dwRet != ET_S_SUCCESS)
	{
		if(pTemp != NULL)
		{
			delete [] pTemp;
			pTemp = NULL;
		}
		if(pOutBuf != NULL)
		{
			delete [] pOutBuf;
			pOutBuf = NULL;
		}
		
		return S_FALSE;
	}
	
	int iLDouble = iL*2;
	unsigned char *pTempDouble = new unsigned char[iLDouble+1];
	memset(pTempDouble, 0, iLDouble+1);
	Hex2Str(pOutBuf, pTempDouble, iL);
	
	bstr.Append((char*)pTempDouble);
	*bstrOutData = bstr;
	
	if(pTempDouble != NULL)
	{
		delete [] pTempDouble;
		pTempDouble = NULL;
	}
	
	
	if(pTemp != NULL)
	{
		delete [] pTemp;
		pTemp = NULL;
	}
	
	if(pOutBuf != NULL)
	{
		delete [] pOutBuf;
		pOutBuf = NULL;
	}
	
	return S_OK;
}

STDMETHODIMP CET199::TDESDecrypt(BSTR bstrInData, BSTR *bstrOutData)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	if(pContext == NULL)
	{
		//*lRet = -3;
		return S_FALSE;
	}
	
	unsigned char  *pbData;
	unsigned long ulDataLen;
	DWORD dwRet = ET_S_SUCCESS;
	CComBSTR bstr;
	DWORD dwOutLen = 0;
	
	USES_CONVERSION;
	pbData=(BYTE*)OLE2A(bstrInData);
	if(pbData != NULL)
		ulDataLen=strlen((const char*)pbData);
	else
	{
		//*lRet -4;
		return S_FALSE;
	}
	
	if((ulDataLen<=0) || (ulDataLen%128 != 0))
	{
		return S_FALSE;
	}
	
	int iL = ulDataLen/2;
	unsigned char *pTemp = new unsigned char[iL];
	unsigned char *pOutBuf = new unsigned char[iL];
	memset(pTemp, 0, iL);
	memset(pOutBuf, 0, iL);
	Str2Hex((unsigned char*)pbData, pTemp, ulDataLen);
	
	dwRet = ETExecute(pContext, "0006", pTemp, iL, pOutBuf, iL, &dwOutLen);
	if(dwRet != ET_S_SUCCESS)
	{
		//*lRet = -9;
		if(pTemp != NULL)
		{
			delete [] pTemp;
			pTemp = NULL;
		}
		if(pOutBuf != NULL)
		{
			delete [] pOutBuf;
			pOutBuf = NULL;
		}
		return S_FALSE;
	}
	
	int iLReal = iL - pOutBuf[iL-1];
	unsigned char *pTempReal = new unsigned char[iLReal+1];
	memset(pTempReal, 0, iLReal+1);
	memcpy(pTempReal, pOutBuf, iLReal);
	
	bstr.Append((char*)pTempReal);
	*bstrOutData = bstr;
	
	if(pTempReal != NULL)
	{
		delete [] pTempReal;
		pTempReal = NULL;
	}
	
	if(pTemp != NULL)
	{
		delete [] pTemp;
		pTemp = NULL;
	}
	
	if(pOutBuf != NULL)
	{
		delete [] pOutBuf;
		pOutBuf = NULL;
	}
	
	return S_OK;
}
